<template>
  <ob-form
      class="form-add-excel"
      :form-data="formData"
      :is-submit-disabled="!isDisabled"
      :ok-text="'Загрузить файл'"
      :is-loading="isLoading"
      cancel-text="Отменить"
      @submit="onSubmitHandler"
      @cancel="clear"
  >
    <div class="form-add-excel__title">
      Вы можете заполнить таблицу спот-аукционов в Excel, используя специальный шаблон, а затем загрузить все данные в систему.
    </div>
    <div class="row">
      <div class="form-add-excel__number col-xs-12">1. Скачайте шаблон</div>
      <div
        @click="downloadFile"
        class="form-add-excel__link col-xs-12"
      >
        Таблица спот-аукционов в формате XLSX
      </div>
    </div>
    <div class="row">
      <div class="form-add-excel__number col-xs-12">2. Загрузите заполненный шаблон</div>
      <div class="form-add-excel__text col-xs-12">Размер файла не должен превышать 1 Мб.</div>
      <div
        v-if="alertText.length"
        class="form-add-excel__error col-xs-12">
        <i class="icon alert"/> {{alertText}}
      </div>
      <div class="form-add-excel__uploader">
        <ObUploader
            ref="uploader"
            data-qa="uploader"
            :multiple="false"
            @change="onUploadFile($event)"
        />
      </div>
    </div>
  </ob-form>
</template>

<script>
import ObForm from 'common-components/src/obComponents/obForm';
import ObUploader from 'common-components/src/obComponents/obUploader';
import api from '@/api';
import { mapGetters } from "vuex";
export default {
  name: 'ExcelModal',
  components: {
    ObForm,
    ObUploader
  },
  data () {
    return {
      formData: {},
      fileUuid: null,
      isDisabled: false,
      isLoading: false,
      fileTemplate: {
        type: '',
        uuid: ''
      },
      alertText: ''
    };
  },
  computed: {
    ...mapGetters({
      userUuid: 'user/participantUuid'
    })
  },
  async mounted() {
    const res = await api.spotAuction.getListTemplates();
    this.fileTemplate = res.data[0];
  },
  methods: {
    async downloadFile () {
      try {
        this.isLoading = true;
        await api.spotAuction.downloadTemplate({uuid: this.fileTemplate.uuid});
      } catch (e) {
        this.$notification({
          type: 'system_notification_error',
          message: 'Ошибка загрузки файла'
        })
      } finally {
        this.isLoading = false
      }
    },
    async onUploadFile(data) {
      if (data.length) {
        data = data[0];
        if (data.file.type !== 'application/vnd.openxmlformats-officedocument.spreadsheetml.sheet') {
          this.alertText = 'Возможно загрузить только XLSX-файл. Измените формат и прикрепите снова.'
        } else if (data.file.size / 1024 / 1024 > 1) {
          this.alertText = 'Файл больше 1 Мб. Уменьшите его размер и прикрепите снова.';
        } else {
          this.alertText = '';
          const jsonData = {
            filename: data.file.name,
            participant_uuid: this.userUuid,
          };
          this.formData = jsonData;
          const form = new FormData();
          form.append('jsonData', JSON.stringify(jsonData));
          form.append('file', data.file);
          await api.spotAuction.postExcelFile(data.uuid, form)
            .then(() => {
              this.isDisabled = true;
              this.fileUuid = data.uuid;
            })
            .catch((error) => {
              this.$notification({
                type: 'system_notification_error',
                message: 'Файл не может быть добавлен'
              });
              console.error('Ошибка добавление файла: ', error);
            })
        }
      } else {
        this.isDisabled = false;
        this.alertText = '';
      }
    },
    async onSubmitHandler() {
      this.isDisabled = false;
      this.isLoading = true;
      await api.spotAuction.saveSpotAuction(this.fileUuid)
        .then(() => {
          this.$notification({
            type: 'system_notification_success',
            message: 'XLSX-документ добавлен'
          });
          this.$emit('close');
          setTimeout(() => {
            this.$notification({type: 'snackbars', message: `Файл обрабатывается, обновите страницу.`});
            this.clear();
          }, 1500);
        })
        .catch((error) => {
          this.isDisabled = true;
          this.$notification({
            type: 'system_notification_error',
            message: 'Файл не может быть добавлен'
          });
          console.error('Ошибка загрузки файла: ', error);
        })
        .finally(() => this.isLoading = false)
    },
    clear () {
      this.$refs.uploader.clearFiles();
      this.fileUuid = null;
      this.isLoading = false;
      this.isDisabled = false;
    }
  }
};
</script>

<style scoped lang="scss">
  .form-add-excel {
    color: #191E32;
    letter-spacing: 0.4px;
    line-height: 20px;
    font-size: 14px;
    &__title {
      line-height: 18px;
      letter-spacing: 0.2px;
      margin: 20px 0;
    }
    &__number {
      font-weight: bold;
      font-size: 16px;
      margin: 6px 0;
    }
    &__link {
      cursor: pointer;
      color: #0070A6;
      margin: 6px 0;
    }
    &__text {
      margin: 6px 0;
    }
    &__error {
      padding: 20px;
      margin: 10px 0;
      background: #fdeaea;
      font-size: 14px;
      line-height: 20px;
      letter-spacing: 0.2px;
      color: #191E32;
      i {
        color: #E62D3B;
        margin-right: 17px;
        font-size: 17px;
      }
    }
    &__uploader {
      width: 100%;
    }
  }
</style>
